<template>
  <fieldset
    class="ui-checkbox-group group flex flex-col text-base lg:text-lg xl:text-xl [&_.ui-form-hints_.hints]:mb-1"
    v-bind="filteredAttrs"
    :class="[
      {
        '[&_.ui-form-hints_.hints]:text-gray-400': disabled,
        '[&_.ui-form-errors_.errors]:mt-4': !isGridChild,
        'contents [&_.ui-form-errors]:col-span-full [&_.ui-form-errors]:place-self-stretch [&_.ui-form-errors_.errors]:rounded-none [&_.ui-form-errors_.errors]:border-0 [&_.ui-form-errors_.errors]:py-1':
          isGridChild,
        '[&:not(:last-child)_.ui-form-errors]:border-b [&:not(:last-child)_.ui-form-errors]:border-b-gray-300':
          isGridChild && !hasErrors,
        '[&_.ui-form-errors]:-ml-3 [&_.ui-form-errors]:mb-2 [&_.ui-form-errors]:border-b-4 [&_.ui-form-errors]:border-l-4 [&_.ui-form-errors]:border-red-600':
          isGridChild && hasErrors,
        'has-errors': hasErrors,
      },

      $attrs.class,
    ]"
    :style="$attrs.style"
    :aria-describedby="hintsId"
    :aria-errormessage="errorsId"
  >
    <legend :class="{ 'place-self-start': isGridChild }">
      <slot :label="label" :required="required" name="label">
        <div
          class="leading-relaxed motion-safe:transition-colors"
          :class="{
            'font-medium group-focus-within:text-violet-700': !hasErrors,
            'py-3': isGridChild,
            'font-bold text-red-600 group-focus-within:text-red-700': hasErrors,
            '-ml-3 border-l-4 border-l-red-600 pl-2': isGridChild && hasErrors,
          }"
        >
          <span
            v-if="highlighted"
            aria-hidden="true"
            class="-ml-6 -mt-1 inline-block h-0 w-8 overflow-visible align-top text-2xl motion-safe:-ml-8 motion-safe:animate-point-right md:-ml-12 md:w-12 md:text-3xl"
            >👉</span
          >{{ label }}<span aria-hidden="true">{{ required ? '*' : '' }}</span>
        </div>
      </slot>
    </legend>
    <slot :hints-id="hintsId" :hints="mergedHints" name="hints">
      <ui-form-hints
        :hints-id="hintsId"
        :hints="mergedHints"
        :class="{ 'sr-only': isGridChild }"
      />
    </slot>
    <div
      class="mt-2 border-l-4 pl-2 motion-safe:transition-all"
      :class="{
        'border-transparent': !hasErrors,
        'space-y-4': !isGridChild,
        contents: isGridChild,
        'border-red-600': hasErrors,
        '-ml-3': buttons && !hasErrors,
        'ml-0': buttons && hasErrors,
      }"
    >
      <slot
        :disabled="disabled"
        :invalid="hasErrors"
        :options="options"
        :native-name="inputId"
        :button="buttons"
      >
        <ui-checkbox
          v-for="(option, index) of options"
          :key="optionKey(option, index)"
          :model-value="modelValue"
          :value="typeof option === 'object' ? option.id : option"
          :name="inputId"
          :button="buttons"
          :disabled="
            disabled || (typeof option === 'object' && option.disabled)
          "
          :labelled-by-id="
            typeof option === 'object' ? option?.labelledById : undefined
          "
          @update:model-value="onChange"
        >
          {{
            typeof option !== 'object'
              ? option
              : option.label ?? option.id ?? option
          }}
        </ui-checkbox>
      </slot>
    </div>
    <slot :errors-id="errorsId" :errors="parsedErrors" name="errors">
      <ui-form-errors :errors-id="errorsId" :errors="parsedErrors" />
    </slot>
  </fieldset>
</template>

<script lang="ts" setup>
import { computed, useAttrs, PropType } from 'vue'
import { useFormElementErrors, useFormElementId } from '../../composables'
import { CheckboxGroupOption } from '../../propInterfaces'
import UiFormHints from './FormHints.vue'
import UiFormErrors from './FormErrors.vue'
import UiCheckbox from './Checkbox.vue'

defineOptions({
  name: 'UiCheckboxGroup',
  inheritAttrs: false,
})

const props = defineProps({
  disabled: {
    type: Boolean,
    default: false,
  },
  hints: {
    type: [String, Array] as PropType<string | string[]>,
    default: () => [],
  },
  label: {
    type: String,
    default: undefined,
  },
  name: {
    type: String,
    default: '',
  },
  required: {
    type: Boolean,
    default: false,
  },
  highlighted: {
    type: Boolean,
    default: false,
  },
  highlightedHint: {
    type: String,
    default: '',
  },
  modelValue: {
    type: Array as PropType<(string | number | boolean)[]>,
    default: () => [],
  },
  options: {
    type: Array as PropType<
      (string | number | boolean | CheckboxGroupOption)[]
    >,
    default: () => [],
    validate: (array: (string | number | boolean | CheckboxGroupOption)[]) =>
      array.every((option) =>
        typeof option === 'object'
          ? option.id !== undefined &&
            option.id !== null &&
            option.label !== undefined &&
            option.label !== null
          : option !== undefined && option !== null,
      ),
  },
  buttons: {
    type: Boolean,
    default: false,
  },
  errors: {
    type: [String, Array, Boolean] as PropType<string | string[] | boolean>,
    default: () => [],
  },
  touched: {
    type: Boolean,
    default: undefined,
  },
  setTouched: {
    type: Function as PropType<(touched: boolean) => void>,
    default: undefined,
  },
  isGridChild: {
    type: Boolean,
    default: false,
  },
})

const filteredAttrs = computed(() => {
  const { class: _, style, onBlur, ...filteredAttrs } = useAttrs()
  return {
    ...filteredAttrs,
    onBlurCapture: ($event: FocusEvent) => {
      typeof props.setTouched === 'function' && props.setTouched(true) // vee-validate blur handler
      typeof onBlur === 'function' && onBlur($event) // native blur handler
    },
  }
})

const emit = defineEmits(['update:modelValue'])

const onChange = ($event: Event) => emit('update:modelValue', $event)

const mergedHints = computed(() => [
  ...(props.highlightedHint ? [props.highlightedHint] : []),
  ...(Array.isArray(props.hints) ? props.hints : [props.hints]),
])

const { uniqueId, errorsId, hintsId } = useFormElementId(props)

const inputId = computed(() => props.name || uniqueId)

const { hasErrors, parsedErrors } = useFormElementErrors(props)

const optionKey = (
  option: string | number | boolean | CheckboxGroupOption,
  index: number,
) => {
  const key =
    typeof option !== 'object' ? option : option.id ?? option.label ?? index

  if (typeof key === 'boolean') {
    return `bool-${key}`
  }

  return key
}
</script>
